--- old/usr/src/uts/common/fs/sharefs/sharetab.c	Mon Feb  3 11:23:30 2020
+++ new/usr/src/uts/common/fs/sharefs/sharetab.c	Mon Feb  3 11:23:30 2020
@@ -23,6 +23,11 @@
  * Copyright (c) 2007, 2010, Oracle and/or its affiliates. All rights reserved.
  */
 
+/*
+ * Copyright 2018 Nexenta Systems, Inc.
+ * Copyright 2020 Joyent, Inc.
+ */
+
 #include <sys/types.h>
 #include <sys/types32.h>
 #include <sys/param.h>
@@ -47,15 +52,13 @@
  */
 #define	SHARETAB_COPYIN(field)						\
 	if (copyinstr(STRUCT_FGETP(u_sh, sh_##field),			\
-			buf,						\
-			bufsz + 1,	/* Add one for extra NUL */	\
-			&len)) {					\
+	    buf,							\
+	    bufsz + 1,	/* Add one for extra NUL */			\
+	    &len)) {							\
 		error = EFAULT;						\
 		goto cleanup;						\
 	}								\
-	/*								\
-	 * Need to remove 1 because copyinstr() counts the NUL.		\
-	 */								\
+	/* Need to remove 1 because copyinstr() counts the NUL */	\
 	len--;								\
 	sh->sh_##field = kmem_alloc(len + 1, KM_SLEEP);			\
 	bcopy(buf, sh->sh_##field, len);				\
@@ -64,25 +67,14 @@
 	sh->sh_size += shl.shl_##field;	/* Debug counting */
 
 #define	SHARETAB_DELETE_FIELD(field)					\
-	if (sh->sh_##field) {						\
+	if (sh->sh_##field != NULL) {					\
 		kmem_free(sh->sh_##field,				\
-			shl ? shl->shl_##field + 1 :			\
-			strlen(sh->sh_##field) + 1);			\
+		    shl ? shl->shl_##field + 1 :			\
+		    strlen(sh->sh_##field) + 1);			\
 	}
 
-sharetab_t	*sharefs_sharetab = NULL;	/* The incore sharetab. */
-size_t		sharetab_size;
-uint_t		sharetab_count;
+static zone_key_t sharetab_zone_key;
 
-krwlock_t	sharetab_lock;	/* lock to protect the cached sharetab */
-
-krwlock_t	sharefs_lock;	/* lock to protect the vnode ops */
-
-timestruc_t	sharetab_mtime;
-timestruc_t	sharetab_snap_time;
-
-uint_t		sharetab_generation;	/* Only increments and wraps! */
-
 /*
  * Take care of cleaning up a share.
  * If passed in a length array, use it to determine how much
@@ -91,7 +83,7 @@
 static void
 sharefree(share_t *sh, sharefs_lens_t *shl)
 {
-	if (!sh)
+	if (sh == NULL)
 		return;
 
 	SHARETAB_DELETE_FIELD(path);
@@ -100,7 +92,7 @@
 	SHARETAB_DELETE_FIELD(opts);
 	SHARETAB_DELETE_FIELD(descr);
 
-	kmem_free(sh, sizeof (share_t));
+	kmem_free(sh, sizeof (*sh));
 }
 
 /*
@@ -108,7 +100,7 @@
  * cleaning up the memory associated with the share argument.
  */
 static int
-sharefs_remove(share_t *sh, sharefs_lens_t *shl)
+sharefs_remove(sharetab_globals_t *sg, share_t *sh, sharefs_lens_t *shl)
 {
 	int		iHash;
 	sharetab_t	*sht;
@@ -118,11 +110,10 @@
 	if (!sh)
 		return (ENOENT);
 
-	rw_enter(&sharetab_lock, RW_WRITER);
-	for (sht = sharefs_sharetab; sht != NULL; sht = sht->s_next) {
-		if (strcmp(sh->sh_fstype, sht->s_fstype) == 0) {
+	rw_enter(&sg->sharetab_lock, RW_WRITER);
+	for (sht = sg->sharefs_sharetab; sht != NULL; sht = sht->s_next) {
+		if (strcmp(sh->sh_fstype, sht->s_fstype) == 0)
 			break;
-		}
 	}
 
 	/*
@@ -129,12 +120,12 @@
 	 * There does not exist a fstype in memory which
 	 * matches the share passed in.
 	 */
-	if (!sht) {
-		rw_exit(&sharetab_lock);
+	if (sht == NULL) {
+		rw_exit(&sg->sharetab_lock);
 		return (ENOENT);
 	}
 
-	iPath = shl ? shl->shl_path : strlen(sh->sh_path);
+	iPath = shl != NULL ? shl->shl_path : strlen(sh->sh_path);
 	iHash = pkp_tab_hash(sh->sh_path, strlen(sh->sh_path));
 
 	/*
@@ -147,22 +138,21 @@
 		 */
 		if (strcmp(sh->sh_path, s->sh_path) == 0 &&
 		    strlen(s->sh_path) == iPath) {
-			if (p) {
+			if (p != NULL)
 				p->sh_next = s->sh_next;
-			} else {
+			else
 				sht->s_buckets[iHash].ssh_sh = s->sh_next;
-			}
 
 			ASSERT(sht->s_buckets[iHash].ssh_count != 0);
 			atomic_dec_32(&sht->s_buckets[iHash].ssh_count);
 			atomic_dec_32(&sht->s_count);
-			atomic_dec_32(&sharetab_count);
+			atomic_dec_32(&sg->sharetab_count);
 
-			ASSERT(sharetab_size >= s->sh_size);
-			sharetab_size -= s->sh_size;
+			ASSERT(sg->sharetab_size >= s->sh_size);
+			sg->sharetab_size -= s->sh_size;
 
-			gethrestime(&sharetab_mtime);
-			atomic_inc_32(&sharetab_generation);
+			gethrestime(&sg->sharetab_mtime);
+			atomic_inc_32(&sg->sharetab_generation);
 
 			break;
 		}
@@ -170,18 +160,15 @@
 		p = s;
 	}
 
-	rw_exit(&sharetab_lock);
+	rw_exit(&sg->sharetab_lock);
 
-	if (!s) {
+	if (s == NULL)
 		return (ENOENT);
-	}
 
 	s->sh_next = NULL;
 	sharefree(s, NULL);
 
-	/*
-	 * We need to free the share for the caller.
-	 */
+	/* We need to free the share for the caller */
 	sharefree(sh, shl);
 
 	return (0);
@@ -191,7 +178,7 @@
  * The caller must have allocated memory for us to use.
  */
 static int
-sharefs_add(share_t *sh, sharefs_lens_t *shl)
+sharefs_add(sharetab_globals_t *sg, share_t *sh, sharefs_lens_t *shl)
 {
 	int		iHash;
 	sharetab_t	*sht;
@@ -199,41 +186,31 @@
 	int		iPath;
 	int		n;
 
-	if (!sh) {
+	if (sh == NULL)
 		return (ENOENT);
-	}
 
-	/*
-	 * We need to find the hash buckets for the fstype.
-	 */
-	rw_enter(&sharetab_lock, RW_WRITER);
-	for (sht = sharefs_sharetab; sht != NULL; sht = sht->s_next) {
-		if (strcmp(sh->sh_fstype, sht->s_fstype) == 0) {
+	/* We need to find the hash buckets for the fstype */
+	rw_enter(&sg->sharetab_lock, RW_WRITER);
+	for (sht = sg->sharefs_sharetab; sht != NULL; sht = sht->s_next) {
+		if (strcmp(sh->sh_fstype, sht->s_fstype) == 0)
 			break;
-		}
 	}
 
-	/*
-	 * Did not exist, so allocate one and add it to the
-	 * sharetab.
-	 */
-	if (!sht) {
+	/* Did not exist, so allocate one and add it to the sharetab */
+	if (sht == NULL) {
 		sht = kmem_zalloc(sizeof (*sht), KM_SLEEP);
 		n = strlen(sh->sh_fstype);
 		sht->s_fstype = kmem_zalloc(n + 1, KM_SLEEP);
 		(void) strncpy(sht->s_fstype, sh->sh_fstype, n);
 
-		sht->s_next = sharefs_sharetab;
-		sharefs_sharetab = sht;
+		sht->s_next = sg->sharefs_sharetab;
+		sg->sharefs_sharetab = sht;
 	}
 
-	/*
-	 * Now we need to find where we have to add the entry.
-	 */
+	/* Now we need to find where we have to add the entry */
+	iPath = shl != NULL ? shl->shl_path : strlen(sh->sh_path);
 	iHash = pkp_tab_hash(sh->sh_path, strlen(sh->sh_path));
 
-	iPath = shl ? shl->shl_path : strlen(sh->sh_path);
-
 	if (shl) {
 		sh->sh_size = shl->shl_path + shl->shl_res +
 		    shl->shl_fstype + shl->shl_opts + shl->shl_descr;
@@ -243,15 +220,10 @@
 		    strlen(sh->sh_opts) + strlen(sh->sh_descr);
 	}
 
-	/*
-	 * We need to account for field seperators and
-	 * the EOL.
-	 */
+	/* We need to account for field separators and the EOL */
 	sh->sh_size += 5;
 
-	/*
-	 * Now walk down the hash table and add the new entry!
-	 */
+	/* Now walk down the hash table and add the new entry */
 	for (p = NULL, s = sht->s_buckets[iHash].ssh_sh;
 	    s != NULL; s = s->sh_next) {
 		/*
@@ -263,28 +235,25 @@
 		 */
 		if (strcmp(sh->sh_path, s->sh_path) == 0 &&
 		    strlen(s->sh_path) == iPath) {
-			if (p) {
+			if (p != NULL)
 				p->sh_next = sh;
-			} else {
+			else
 				sht->s_buckets[iHash].ssh_sh = sh;
-			}
 
 			sh->sh_next = s->sh_next;
 
-			ASSERT(sharetab_size >= s->sh_size);
-			sharetab_size -= s->sh_size;
-			sharetab_size += sh->sh_size;
+			ASSERT(sg->sharetab_size >= s->sh_size);
+			sg->sharetab_size -= s->sh_size;
+			sg->sharetab_size += sh->sh_size;
 
-			/*
-			 * Get rid of the old node.
-			 */
+			/* Get rid of the old node */
 			sharefree(s, NULL);
 
-			gethrestime(&sharetab_mtime);
-			atomic_inc_32(&sharetab_generation);
+			gethrestime(&sg->sharetab_mtime);
+			atomic_inc_32(&sg->sharetab_generation);
 
 			ASSERT(sht->s_buckets[iHash].ssh_count != 0);
-			rw_exit(&sharetab_lock);
+			rw_exit(&sg->sharetab_lock);
 
 			return (0);
 		}
@@ -300,29 +269,82 @@
 	sht->s_buckets[iHash].ssh_sh = sh;
 	atomic_inc_32(&sht->s_buckets[iHash].ssh_count);
 	atomic_inc_32(&sht->s_count);
-	atomic_inc_32(&sharetab_count);
-	sharetab_size += sh->sh_size;
+	atomic_inc_32(&sg->sharetab_count);
+	sg->sharetab_size += sh->sh_size;
 
-	gethrestime(&sharetab_mtime);
-	atomic_inc_32(&sharetab_generation);
+	gethrestime(&sg->sharetab_mtime);
+	atomic_inc_32(&sg->sharetab_generation);
 
-	rw_exit(&sharetab_lock);
+	rw_exit(&sg->sharetab_lock);
 
 	return (0);
 }
 
+/* ARGSUSED */
+static void *
+sharetab_zone_init(zoneid_t zoneid)
+{
+	sharetab_globals_t *sg;
+
+	sg = kmem_zalloc(sizeof (*sg), KM_SLEEP);
+
+	rw_init(&sg->sharetab_lock, NULL, RW_DEFAULT, NULL);
+	rw_init(&sg->sharefs_lock, NULL, RW_DEFAULT, NULL);
+
+	sg->sharetab_size = 0;
+	sg->sharetab_count = 0;
+	sg->sharetab_generation = 1;
+
+	gethrestime(&sg->sharetab_mtime);
+	gethrestime(&sg->sharetab_snap_time);
+
+	return (sg);
+}
+
+/* ARGSUSED */
+static void
+sharetab_zone_fini(zoneid_t zoneid, void *data)
+{
+	sharetab_globals_t *sg = data;
+
+	rw_destroy(&sg->sharefs_lock);
+	rw_destroy(&sg->sharetab_lock);
+
+	/* ALL of the allocated things must be cleaned before we free sg. */
+	while (sg->sharefs_sharetab != NULL) {
+		int i;
+		sharetab_t *freeing = sg->sharefs_sharetab;
+
+		sg->sharefs_sharetab = freeing->s_next;
+		kmem_free(freeing->s_fstype, strlen(freeing->s_fstype) + 1);
+		for (i = 0; i < PKP_HASH_SIZE; i++) {
+			sharefs_hash_head_t *bucket;
+
+			bucket = &(freeing->s_buckets[i]);
+			while (bucket->ssh_sh != NULL) {
+				share_t *share = bucket->ssh_sh;
+
+				bucket->ssh_sh = share->sh_next;
+				sharefree(share, NULL);
+			}
+		}
+		kmem_free(freeing, sizeof (*freeing));
+	}
+
+	kmem_free(sg, sizeof (*sg));
+}
+
 void
 sharefs_sharetab_init(void)
 {
-	rw_init(&sharetab_lock, NULL, RW_DEFAULT, NULL);
-	rw_init(&sharefs_lock, NULL, RW_DEFAULT, NULL);
+	zone_key_create(&sharetab_zone_key, sharetab_zone_init,
+	    NULL, sharetab_zone_fini);
+}
 
-	sharetab_size = 0;
-	sharetab_count = 0;
-	sharetab_generation = 1;
-
-	gethrestime(&sharetab_mtime);
-	gethrestime(&sharetab_snap_time);
+sharetab_globals_t *
+sharetab_get_globals(zone_t *zone)
+{
+	return (zone_getspecific(sharetab_zone_key, zone));
 }
 
 int
@@ -332,12 +354,10 @@
 	size_t		len;
 	size_t		bufsz;
 	share_t		*sh;
-
 	sharefs_lens_t	shl;
-
 	model_t		model;
-
 	char		*buf = NULL;
+	sharetab_globals_t *sg = sharetab_get_globals(curzone);
 
 	STRUCT_DECL(share, u_sh);
 
@@ -347,20 +367,20 @@
 	 * Before we do anything, lets make sure we have
 	 * a sharetab in memory if we need one.
 	 */
-	rw_enter(&sharetab_lock, RW_READER);
+	rw_enter(&sg->sharetab_lock, RW_READER);
 	switch (opcode) {
-	case (SHAREFS_REMOVE) :
-	case (SHAREFS_REPLACE) :
-		if (!sharefs_sharetab) {
-			rw_exit(&sharetab_lock);
+	case SHAREFS_REMOVE:
+	case SHAREFS_REPLACE:
+		if (!sg->sharefs_sharetab) {
+			rw_exit(&sg->sharetab_lock);
 			return (set_errno(ENOENT));
 		}
 		break;
-	case (SHAREFS_ADD) :
-	default :
+	case SHAREFS_ADD:
+	default:
 		break;
 	}
-	rw_exit(&sharetab_lock);
+	rw_exit(&sg->sharetab_lock);
 
 	model = get_udatamodel();
 
@@ -368,42 +388,31 @@
 	 * Initialize the data pointers.
 	 */
 	STRUCT_INIT(u_sh, model);
-	if (copyin(sh_in, STRUCT_BUF(u_sh), STRUCT_SIZE(u_sh))) {
+	if (copyin(sh_in, STRUCT_BUF(u_sh), STRUCT_SIZE(u_sh)))
 		return (set_errno(EFAULT));
-	}
 
-	/*
-	 * Get the share.
-	 */
+	/* Get the share */
 	sh = kmem_zalloc(sizeof (share_t), KM_SLEEP);
 
-	/*
-	 * Get some storage for copying in the strings.
-	 */
+	/* Get some storage for copying in the strings */
 	buf = kmem_zalloc(bufsz + 1, KM_SLEEP);
 	bzero(&shl, sizeof (sharefs_lens_t));
 
-	/*
-	 * Only grab these two until we know what we want.
-	 */
+	/* Only grab these two until we know what we want */
 	SHARETAB_COPYIN(path);
 	SHARETAB_COPYIN(fstype);
 
 	switch (opcode) {
-	case (SHAREFS_ADD) :
-	case (SHAREFS_REPLACE) :
+	case SHAREFS_ADD:
+	case SHAREFS_REPLACE:
 		SHARETAB_COPYIN(res);
 		SHARETAB_COPYIN(opts);
 		SHARETAB_COPYIN(descr);
-
-		error = sharefs_add(sh, &shl);
+		error = sharefs_add(sg, sh, &shl);
 		break;
-
-	case (SHAREFS_REMOVE) :
-
-		error = sharefs_remove(sh, &shl);
+	case SHAREFS_REMOVE:
+		error = sharefs_remove(sg, sh, &shl);
 		break;
-
 	default:
 		error = EINVAL;
 		break;
@@ -410,7 +419,6 @@
 	}
 
 cleanup:
-
 	/*
 	 * If there is no error, then we have stashed the structure
 	 * away in the sharetab hash table or have deleted it.
@@ -418,22 +426,38 @@
 	 * Either way, the only reason to blow away the data is if
 	 * there was an error.
 	 */
-	if (error != 0) {
+	if (error != 0)
 		sharefree(sh, &shl);
-	}
 
-	if (buf) {
+	if (buf != NULL)
 		kmem_free(buf, bufsz + 1);
-	}
 
-	return ((error != 0) ? set_errno(error) : 0);
+	return (error != 0 ? set_errno(error) : 0);
 }
 
 int
 sharefs(enum sharefs_sys_op opcode, share_t *sh_in, uint32_t iMaxLen)
 {
-	if (secpolicy_sys_config(CRED(), B_FALSE) != 0)
-		return (set_errno(EPERM));
+	/*
+	 * If we're in the global zone PRIV_SYS_CONFIG gives us the
+	 * privileges needed to act on sharetab. However if we're in
+	 * a non-global zone PRIV_SYS_CONFIG is not allowed. To work
+	 * around this issue PRIV_SYS_NFS is used in this case.
+	 *
+	 * TODO: This basically overloads the definition/use of
+	 * PRIV_SYS_NFS to work around the limitation of PRIV_SYS_CONFIG
+	 * in a zone. Solaris 11 solved this by implementing a PRIV_SYS_SHARE
+	 * we should do the same and replace the use of PRIV_SYS_NFS here and
+	 * in zfs_secpolicy_share.
+	 */
+	if (INGLOBALZONE(curproc)) {
+		if (secpolicy_sys_config(CRED(), B_FALSE) != 0)
+			return (set_errno(EPERM));
+	} else {
+		/* behave like zfs_secpolicy_share() */
+		if (secpolicy_nfs(CRED()) != 0)
+			return (set_errno(EPERM));
 
+	}
 	return (sharefs_impl(opcode, sh_in, iMaxLen));
 }
--- old/usr/src/uts/common/fs/zfs/zfs_ioctl.c	Mon Feb  3 11:23:30 2020
+++ new/usr/src/uts/common/fs/zfs/zfs_ioctl.c	Mon Feb  3 11:23:30 2020
@@ -21,10 +21,13 @@
 
 /*
  * Copyright (c) 2005, 2010, Oracle and/or its affiliates. All rights reserved.
+ */
+
+/*
  * Copyright (c) 2011-2012 Pawel Jakub Dawidek. All rights reserved.
  * Portions Copyright 2011 Martin Matuska
  * Copyright 2015, OmniTI Computer Consulting, Inc. All rights reserved.
- * Copyright 2016 Nexenta Systems, Inc.  All rights reserved.
+ * Copyright 2018 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2019 Joyent, Inc.
  * Copyright (c) 2011, 2017 by Delphix. All rights reserved.
  * Copyright (c) 2013 by Saso Kiselkov. All rights reserved.
@@ -787,9 +790,6 @@
 int
 zfs_secpolicy_share(zfs_cmd_t *zc, nvlist_t *innvl, cred_t *cr)
 {
-	if (!INGLOBALZONE(curproc))
-		return (SET_ERROR(EPERM));
-
 	if (secpolicy_nfs(cr) == 0) {
 		return (0);
 	} else {
@@ -800,9 +800,6 @@
 int
 zfs_secpolicy_smb_acl(zfs_cmd_t *zc, nvlist_t *innvl, cred_t *cr)
 {
-	if (!INGLOBALZONE(curproc))
-		return (SET_ERROR(EPERM));
-
 	if (secpolicy_smb(cr) == 0) {
 		return (0);
 	} else {
--- old/usr/src/uts/common/klm/klmmod.c	Mon Feb  3 11:23:31 2020
+++ new/usr/src/uts/common/klm/klmmod.c	Mon Feb  3 11:23:31 2020
@@ -92,6 +92,7 @@
 
 	g->lockd_pid = 0;
 	g->run_status = NLM_ST_DOWN;
+	g->nlm_zoneid = zoneid;
 
 	nlm_globals_register(g);
 	return (g);
@@ -103,6 +104,8 @@
 {
 	struct nlm_globals *g = data;
 
+	nlm_globals_unregister(g);
+
 	ASSERT(avl_is_empty(&g->nlm_hosts_tree));
 	avl_destroy(&g->nlm_hosts_tree);
 	mod_hash_destroy_idhash(g->nlm_hosts_hash);
@@ -113,7 +116,6 @@
 	cv_destroy(&g->nlm_gc_finish_cv);
 	mutex_destroy(&g->clean_lock);
 
-	nlm_globals_unregister(g);
 	kmem_free(g, sizeof (*g));
 }
 
--- old/usr/src/uts/common/klm/nlm_impl.c	Mon Feb  3 11:23:31 2020
+++ new/usr/src/uts/common/klm/nlm_impl.c	Mon Feb  3 11:23:31 2020
@@ -843,7 +843,7 @@
 	 * statd using the status monitor protocol.
 	 */
 	error = clnt_tli_kcreate(&nsm->ns_knc, &nsm->ns_addr, SM_PROG, SM_VERS,
-	    0, NLM_RPC_RETRIES, kcred, &nsm->ns_handle);
+	    0, NLM_RPC_RETRIES, zone_kcred(), &nsm->ns_handle);
 	if (error != 0)
 		goto error;
 
@@ -852,7 +852,8 @@
 	 * local statd using the address registration protocol.
 	 */
 	error = clnt_tli_kcreate(&nsm->ns_knc, &nsm->ns_addr, NSM_ADDR_PROGRAM,
-	    NSM_ADDR_V1, 0, NLM_RPC_RETRIES, kcred, &nsm->ns_addr_handle);
+	    NSM_ADDR_V1, 0, NLM_RPC_RETRIES, zone_kcred(),
+	    &nsm->ns_addr_handle);
 	if (error != 0)
 		goto error;
 
@@ -861,8 +862,11 @@
 
 error:
 	kmem_free(nsm->ns_addr.buf, nsm->ns_addr.maxlen);
-	if (nsm->ns_handle)
+	if (nsm->ns_handle) {
+		ASSERT(nsm->ns_handle->cl_auth != NULL);
+		auth_destroy(nsm->ns_handle->cl_auth);
 		CLNT_DESTROY(nsm->ns_handle);
+	}
 
 	return (error);
 }
@@ -871,8 +875,12 @@
 nlm_nsm_fini(struct nlm_nsm *nsm)
 {
 	kmem_free(nsm->ns_addr.buf, nsm->ns_addr.maxlen);
+	if (nsm->ns_addr_handle->cl_auth != NULL)
+		auth_destroy(nsm->ns_addr_handle->cl_auth);
 	CLNT_DESTROY(nsm->ns_addr_handle);
 	nsm->ns_addr_handle = NULL;
+	if (nsm->ns_handle->cl_auth != NULL)
+		auth_destroy(nsm->ns_handle->cl_auth);
 	CLNT_DESTROY(nsm->ns_handle);
 	nsm->ns_handle = NULL;
 	sema_destroy(&nsm->ns_sem);
@@ -2562,14 +2570,17 @@
  * on them.
  */
 void
-nlm_unexport(struct exportinfo *exi)
+nlm_zone_unexport(struct nlm_globals *g, struct exportinfo *exi)
 {
-	struct nlm_globals *g;
 	struct nlm_host *hostp;
 
-	g = zone_getspecific(nlm_zone_key, curzone);
-
 	mutex_enter(&g->lock);
+	if (g->run_status != NLM_ST_UP) {
+		/* nothing to do */
+		mutex_exit(&g->lock);
+		return;
+	}
+
 	hostp = avl_first(&g->nlm_hosts_tree);
 	while (hostp != NULL) {
 		struct nlm_vhold *nvp;
@@ -2617,6 +2628,28 @@
 	mutex_exit(&g->lock);
 }
 
+void
+nlm_unexport(struct exportinfo *exi)
+{
+	struct nlm_globals *g;
+
+	rw_enter(&lm_lck, RW_READER);
+	TAILQ_FOREACH(g, &nlm_zones_list, nlm_link) {
+		if (g->nlm_zoneid == exi->exi_zoneid) {
+			/*
+			 * NOTE: If we want to drop lm_lock before
+			 * calling nlm_zone_unexport(), we should break,
+			 * and have a post-rw_exit() snippit like:
+			 *	if (g != NULL)
+			 *		nlm_zone_unexport(g, exi);
+			 */
+			nlm_zone_unexport(g, exi);
+			break; /* Only going to match once! */
+		}
+	}
+	rw_exit(&lm_lck);
+}
+
 /*
  * Allocate new unique sysid.
  * In case of failure (no available sysids)
@@ -2785,7 +2818,7 @@
 nlm_nsm_clnt_init(CLIENT *clnt, struct nlm_nsm *nsm)
 {
 	(void) clnt_tli_kinit(clnt, &nsm->ns_knc, &nsm->ns_addr, 0,
-	    NLM_RPC_RETRIES, kcred);
+	    NLM_RPC_RETRIES, zone_kcred());
 }
 
 static void
--- old/usr/src/uts/common/klm/nlm_impl.h	Mon Feb  3 11:23:31 2020
+++ new/usr/src/uts/common/klm/nlm_impl.h	Mon Feb  3 11:23:31 2020
@@ -459,6 +459,7 @@
 	int				cn_idle_tmo;		/* (z) */
 	int				grace_period;		/* (z) */
 	int				retrans_tmo;		/* (z) */
+	zoneid_t			nlm_zoneid;		/* (c) */
 	kmutex_t			clean_lock;		/* (c) */
 	TAILQ_ENTRY(nlm_globals)	nlm_link;		/* (g) */
 };
--- old/usr/src/uts/common/nfs/export.h	Mon Feb  3 11:23:31 2020
+++ new/usr/src/uts/common/nfs/export.h	Mon Feb  3 11:23:31 2020
@@ -23,6 +23,7 @@
  * Copyright (c) 1989, 2010, Oracle and/or its affiliates. All rights reserved.
  * Copyright 2016 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2016 Jason King.
+ * Copyright 2018 Nexenta Systems, Inc.  All rights reserved.
  */
 
 /*	Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T	*/
@@ -37,7 +38,12 @@
 #include <nfs/nfs4.h>
 #include <sys/kiconv.h>
 #include <sys/avl.h>
+#include <sys/zone.h>
 
+#ifdef _KERNEL
+#include <sys/pkp_hash.h> /* for PKP_HASH_SIZE */
+#endif /* _KERNEL */
+
 #ifdef	__cplusplus
 extern "C" {
 #endif
@@ -467,19 +473,25 @@
 } treenode_t;
 
 /*
- * TREE_ROOT checks if the node corresponds to a filesystem root
+ * Now that we have links to chase, we can get the zone rootvp just from
+ * an export.  No current-zone-context needed.
+ */
+#define	EXI_TO_ZONEROOTVP(exi) ((exi)->exi_ne->exi_root->exi_vp)
+
+/*
+ * TREE_ROOT checks if the node corresponds to a filesystem root or
+ * the zone's root directory.
  * TREE_EXPORTED checks if the node is explicitly shared
  */
 
 #define	TREE_ROOT(t) \
-	((t)->tree_exi && (t)->tree_exi->exi_vp->v_flag & VROOT)
+	((t)->tree_exi != NULL && \
+	(((t)->tree_exi->exi_vp->v_flag & VROOT) || \
+	VN_CMP(EXI_TO_ZONEROOTVP((t)->tree_exi), (t)->tree_exi->exi_vp)))
 
 #define	TREE_EXPORTED(t) \
 	((t)->tree_exi && !PSEUDO((t)->tree_exi))
 
-/* Root of nfs pseudo namespace */
-extern treenode_t *ns_root;
-
 #define	EXPTABLESIZE   256
 
 struct exp_hash {
@@ -517,6 +529,7 @@
 	krwlock_t		exi_cache_lock;
 	kmutex_t		exi_lock;
 	uint_t			exi_count;
+	zoneid_t		exi_zoneid;
 	vnode_t			*exi_vp;
 	vnode_t			*exi_dvp;
 	avl_tree_t		*exi_cache[AUTH_TABLESIZE];
@@ -525,11 +538,20 @@
 	struct charset_cache	*exi_charset;
 	unsigned		exi_volatile_dev:1;
 	unsigned		exi_moved:1;
+	int			exi_id;
+	avl_node_t		exi_id_link;
+	/*
+	 * Soft-reference/backpointer to zone's nfs_export_t.
+	 * This allows us access to the zone's rootvp (stored in
+	 * exi_ne->exi_root->exi_vp) even if the current thread isn't in
+	 * same-zone context.
+	 */
+	struct nfs_export	*exi_ne;
 #ifdef VOLATILE_FH_TEST
 	uint32_t		exi_volatile_id;
 	struct ex_vol_rename	*exi_vol_rename;
 	kmutex_t		exi_vol_rename_lock;
-#endif /* VOLATILE_FH_TEST */
+#endif /* VOLATILE_FH_TEST -- keep last! */
 };
 
 typedef struct exportinfo exportinfo_t;
@@ -608,8 +630,12 @@
     struct svc_req *, int, int, cred_t *);
 extern int	nfsauth_cache_clnt_compar(const void *, const void *);
 extern int	nfs_fhbcmp(char *, char *, int);
-extern int	nfs_exportinit(void);
+extern void	nfs_exportinit(void);
 extern void	nfs_exportfini(void);
+extern void	nfs_export_zone_init(nfs_globals_t *);
+extern void	nfs_export_zone_fini(nfs_globals_t *);
+extern void	nfs_export_zone_shutdown(nfs_globals_t *);
+extern int	nfs_export_get_rootfh(nfs_globals_t *);
 extern int	chk_clnt_sec(struct exportinfo *, struct svc_req *);
 extern int	makefh(fhandle_t *, struct vnode *, struct exportinfo *);
 extern int	makefh_ol(fhandle_t *, struct exportinfo *, uint_t);
@@ -625,32 +651,61 @@
     int *, bool_t);
 extern int	nfs_check_vpexi(vnode_t *, vnode_t *, cred_t *,
 			struct exportinfo **);
-extern void	export_link(struct exportinfo *);
-extern void	export_unlink(struct exportinfo *);
-extern vnode_t *untraverse(vnode_t *);
+extern vnode_t *untraverse(vnode_t *, vnode_t *);
 extern int	vn_is_nfs_reparse(vnode_t *, cred_t *);
 extern int	client_is_downrev(struct svc_req *);
 extern char    *build_symlink(vnode_t *, cred_t *, size_t *);
 
+extern fhandle_t nullfh2;	/* for comparing V2 filehandles */
+
+typedef struct nfs_export {
+	/* Root of nfs pseudo namespace */
+	treenode_t *ns_root;
+
+	nfs_globals_t		*ne_globals;	/* "up" pointer */
+
+	struct exportinfo *exptable_path_hash[PKP_HASH_SIZE];
+	struct exportinfo *exptable[EXPTABLESIZE];
+
+	/*
+	 * Read/Write lock that protects the exportinfo list.  This lock
+	 * must be held when searching or modifiying the exportinfo list.
+	 */
+	krwlock_t exported_lock;
+
+	/* "public" and default (root) location for public filehandle */
+	struct exportinfo *exi_public;
+	struct exportinfo *exi_root;
+	/* For checking default public file handle */
+	fid_t exi_rootfid;
+	/* For comparing V2 filehandles */
+	fhandle_t nullfh2;
+
+	/* The change attribute value of the root of nfs pseudo namespace */
+	timespec_t ns_root_change;
+} nfs_export_t;
+
 /*
  * Functions that handle the NFSv4 server namespace
  */
 extern exportinfo_t *vis2exi(treenode_t *);
 extern int	treeclimb_export(struct exportinfo *);
-extern void	treeclimb_unexport(struct exportinfo *);
+extern void	treeclimb_unexport(nfs_export_t *, struct exportinfo *);
 extern int	nfs_visible(struct exportinfo *, vnode_t *, int *);
 extern int	nfs_visible_inode(struct exportinfo *, ino64_t,
-    struct exp_visible **);
+		    struct exp_visible **);
 extern int	has_visible(struct exportinfo *, vnode_t *);
 extern void	free_visible(struct exp_visible *);
 extern int	nfs_exported(struct exportinfo *, vnode_t *);
-extern struct exportinfo *pseudo_exportfs(vnode_t *, fid_t *,
-    struct exp_visible *, struct exportdata *);
+extern struct exportinfo *pseudo_exportfs(nfs_export_t *, vnode_t *, fid_t *,
+		    struct exp_visible *, struct exportdata *);
 extern int	vop_fid_pseudo(vnode_t *, fid_t *);
 extern int	nfs4_vget_pseudo(struct exportinfo *, vnode_t **, fid_t *);
 extern bool_t	nfs_visible_change(struct exportinfo *, vnode_t *,
-    timespec_t *);
-extern void	tree_update_change(treenode_t *, timespec_t *);
+		    timespec_t *);
+extern void	tree_update_change(nfs_export_t *, treenode_t *, timespec_t *);
+extern void	rfs4_clean_state_exi(nfs_export_t *, struct exportinfo *);
+
 /*
  * Functions that handle the NFSv4 server namespace security flavors
  * information.
@@ -658,13 +713,16 @@
 extern void	srv_secinfo_exp2pseu(struct exportdata *, struct exportdata *);
 extern void	srv_secinfo_list_free(struct secinfo *, int);
 
+extern nfs_export_t *nfs_get_export();
+extern void	export_link(nfs_export_t *, struct exportinfo *);
+extern void	export_unlink(nfs_export_t *, struct exportinfo *);
+
 /*
- * "public" and default (root) location for public filehandle
+ * exi_id support
  */
-extern struct exportinfo *exi_public, *exi_root;
-extern fhandle_t nullfh2;	/* for comparing V2 filehandles */
-extern krwlock_t exported_lock;
-extern struct exportinfo *exptable[];
+extern kmutex_t  nfs_exi_id_lock;
+extern avl_tree_t exi_id_tree;
+extern int exi_id_get_next(void);
 
 /*
  * Two macros for identifying public filehandles.
--- old/usr/src/uts/common/nfs/nfs.h	Mon Feb  3 11:23:31 2020
+++ new/usr/src/uts/common/nfs/nfs.h	Mon Feb  3 11:23:31 2020
@@ -20,19 +20,20 @@
  */
 
 /*
- * Copyright 2014 Nexenta Systems, Inc.  All rights reserved.
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
- * Copyright (c) 2013 by Delphix. All rights reserved.
  */
 
 /*	Copyright (c) 1983, 1984, 1985, 1986, 1987, 1988, 1989 AT&T	*/
 /*	  All Rights Reserved	*/
 
+/*
+ * Copyright (c) 2013 by Delphix. All rights reserved.
+ * Copyright 2019 Nexenta by DDN, Inc. All rights reserved.
+ */
+
 #ifndef	_NFS_NFS_H
 #define	_NFS_NFS_H
 
-/*	nfs.h 2.38 88/08/19 SMI	*/
-
 #include <sys/isa_defs.h>
 #include <sys/vfs.h>
 #include <sys/stream.h>
@@ -72,10 +73,58 @@
 #define	NFS_VERSMIN_DEFAULT	((rpcvers_t)2)
 #define	NFS_VERSMAX_DEFAULT	((rpcvers_t)4)
 
-extern rpcvers_t nfs_versmin;
-extern rpcvers_t nfs_versmax;
+/*
+ * Used to track the state of the server so that initialization
+ * can be done properly.
+ */
+typedef enum {
+	NFS_SERVER_STOPPED,	/* server state destroyed */
+	NFS_SERVER_STOPPING,	/* server state being destroyed */
+	NFS_SERVER_RUNNING,
+	NFS_SERVER_QUIESCED,	/* server state preserved */
+	NFS_SERVER_OFFLINE	/* server pool offline */
+} nfs_server_running_t;
 
+/* Forward declarations for nfs_globals */
+struct nfs_export;
+struct nfs_srv;
+struct nfs3_srv;
+struct nfs4_srv;
+struct nfsauth_globals;
+
 /*
+ * Zone globals variables of NFS server
+ */
+typedef struct nfs_globals {
+	list_node_t		nfs_g_link;	/* all globals list */
+
+	rpcvers_t		nfs_versmin;
+	rpcvers_t		nfs_versmax;
+
+	/* NFS server locks and state */
+	nfs_server_running_t	nfs_server_upordown;
+	kmutex_t		nfs_server_upordown_lock;
+	kcondvar_t		nfs_server_upordown_cv;
+
+	/* RDMA wait variables */
+	kcondvar_t		rdma_wait_cv;
+	kmutex_t		rdma_wait_mutex;
+
+	zoneid_t		nfs_zoneid;
+	/* Per-zone data structures private to each module */
+	struct nfs_export	*nfs_export;	/* nfs_export.c */
+	struct nfs_srv		*nfs_srv;	/* nfs_srv.c */
+	struct nfs3_srv		*nfs3_srv;	/* nfs3_srv.c */
+	struct nfs4_srv		*nfs4_srv;	/* nfs4_srv.c */
+	struct nfsauth_globals	*nfs_auth;	/* nfs_auth.c */
+
+	/* statistic: nfs_stat.c, etc. */
+	kstat_named_t		*svstat[NFS_VERSMAX + 1];
+	kstat_named_t		*rfsproccnt[NFS_VERSMAX + 1];
+	kstat_named_t		*aclproccnt[NFS_VERSMAX + 1];
+} nfs_globals_t;
+
+/*
  * Default delegation setting for the server ==> "on"
  */
 #define	NFS_SERVER_DELEGATION_DEFAULT	(TRUE)
@@ -872,6 +921,8 @@
 extern void	*rfs_statfs_getfh(fhandle_t *);
 extern void	rfs_srvrinit(void);
 extern void	rfs_srvrfini(void);
+extern void	rfs_srv_zone_init(nfs_globals_t *);
+extern void	rfs_srv_zone_fini(nfs_globals_t *);
 
 /*
  * flags to define path types during Multi Component Lookups
@@ -884,6 +935,8 @@
 /* index for svstat_ptr */
 enum nfs_svccounts {NFS_CALLS, NFS_BADCALLS, NFS_REFERRALS, NFS_REFERLINKS};
 
+#define	NFS_V2	NFS_VERSION
+
 /*	function defs for NFS kernel */
 extern int	nfs_waitfor_purge_complete(vnode_t *);
 extern int	nfs_validate_caches(vnode_t *, cred_t *);
@@ -904,7 +957,7 @@
 extern int	nfs_clntinit(void);
 extern void	nfs_clntfini(void);
 extern int	nfstsize(void);
-extern int	nfs_srvinit(void);
+extern void	nfs_srvinit(void);
 extern void	nfs_srvfini(void);
 extern int	vattr_to_sattr(struct vattr *, struct nfssattr *);
 extern void	setdiropargs(struct nfsdiropargs *, char *, vnode_t *);
@@ -942,10 +995,14 @@
     uid_t *, gid_t *, uint_t *, gid_t **);
 extern void	nfsauth_init(void);
 extern void	nfsauth_fini(void);
+extern void	nfsauth_zone_init(nfs_globals_t *);
+extern void	nfsauth_zone_fini(nfs_globals_t *);
+extern void	nfsauth_zone_shutdown(nfs_globals_t *);
 extern int	nfs_setopts(vnode_t *, model_t, struct nfs_args *);
 extern int	nfs_mount_label_policy(vfs_t *, struct netbuf *,
     struct knetconfig *, cred_t *);
 extern boolean_t nfs_has_ctty(void);
+extern nfs_globals_t *nfs_srv_getzg(void);
 extern void	nfs_srv_stop_all(void);
 extern void	nfs_srv_quiesce_all(void);
 extern int	rfs4_dss_setpaths(char *, size_t);
@@ -957,9 +1014,12 @@
 
 extern kstat_named_t	*global_svstat_ptr[];
 
+extern zone_key_t	nfssrv_zone_key;
+extern list_t		nfssrv_globals_list;
+extern krwlock_t	nfssrv_globals_rwl;
+
 extern krwlock_t	rroklock;
 extern vtype_t		nf_to_vt[];
-extern kstat_named_t	*rfsproccnt_v2_ptr;
 extern kmutex_t		nfs_minor_lock;
 extern int		nfs_major;
 extern int		nfs_minor;
@@ -975,9 +1035,7 @@
  */
 struct nfs_version_stats {
 	kstat_named_t	*aclreqcnt_ptr;		/* nfs_acl:0:aclreqcnt_v? */
-	kstat_named_t	*aclproccnt_ptr;	/* nfs_acl:0:aclproccnt_v? */
 	kstat_named_t	*rfsreqcnt_ptr;		/* nfs:0:rfsreqcnt_v? */
-	kstat_named_t	*rfsproccnt_ptr;	/* nfs:0:rfsproccnt_v? */
 };
 
 /*
@@ -984,7 +1042,6 @@
  * A bit of asymmetry: nfs:0:nfs_client isn't part of this structure.
  */
 struct nfs_stats {
-	kstat_named_t		*nfs_stats_svstat_ptr[NFS_VERSMAX + 1];
 	struct nfs_version_stats	nfs_stats_v2;
 	struct nfs_version_stats	nfs_stats_v3;
 	struct nfs_version_stats	nfs_stats_v4;
@@ -1001,6 +1058,9 @@
 extern void	*nfsstat_zone_init(zoneid_t);
 extern void	nfsstat_zone_fini(zoneid_t, void *);
 
+extern void rfs_stat_zone_init(nfs_globals_t *);
+extern void rfs_stat_zone_fini(nfs_globals_t *);
+
 #endif	/* _KERNEL */
 
 /*
@@ -2248,6 +2308,8 @@
 extern void	*rfs3_commit_getfh(COMMIT3args *);
 extern void	rfs3_srvrinit(void);
 extern void	rfs3_srvrfini(void);
+extern void	rfs3_srv_zone_init(nfs_globals_t *);
+extern void	rfs3_srv_zone_fini(nfs_globals_t *);
 
 extern int	nfs3_validate_caches(vnode_t *, cred_t *);
 extern void	nfs3_cache_post_op_attr(vnode_t *, post_op_attr *, hrtime_t,
@@ -2282,7 +2344,6 @@
 extern int	rfs_climb_crossmnt(vnode_t **, struct exportinfo **, cred_t *);
 
 extern vtype_t		nf3_to_vt[];
-extern kstat_named_t	*rfsproccnt_v3_ptr;
 extern vfsops_t		*nfs3_vfsops;
 extern struct vnodeops	*nfs3_vnodeops;
 extern const struct fs_operation_def nfs3_vnodeops_template[];
@@ -2312,11 +2373,11 @@
  * if no delegation is present.
  */
 extern int	rfs4_delegated_getattr(vnode_t *, vattr_t *, int, cred_t *);
-extern void	rfs4_hold_deleg_policy(void);
-extern void	rfs4_rele_deleg_policy(void);
 
 extern int	do_xattr_exists_check(vnode_t *, ulong_t *, cred_t *);
 
+extern int	protect_zfs_mntpt(vnode_t *);
+
 extern ts_label_t *nfs_getflabel(vnode_t *, struct exportinfo *);
 extern boolean_t do_rfs_label_check(bslabel_t *, vnode_t *, int,
     struct exportinfo *);
